import java.awt.event.*;
import java.awt.*;
import java.util.*;

//
// simple entity on the screen
//

public class Box
{
	public double x;
	public double y;
	public double width;
	public double height;

	public Color color;
	
	// Aparent Bounding Box on the screen
	public Rectangle bbox;
	
	Box(double x, double y, double width, double height, Color color){
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
		this.color = color;
	}
	
	
	public void paint(Graphics g, double center_x, double center_y, double scale){
		g.setColor(color);
		update_bbox(center_x, center_y, scale);
		g.fillRect(bbox.x, bbox.y, bbox.width, bbox.height);
	}
	
	public void move_relative(double dx, double dy){
		x += dx;
		y += dy;
	}
	
	public boolean contains(Point p){
		return bbox.contains(p);
	}
	
	public void update_bbox(double center_x, double center_y, double scale){
		bbox =  new Rectangle((int)((x-width/2-center_x)*scale),//+screen_center.x, 
							  (int)((y-height/2-center_y)*scale),//+screen_center.y, 
							 (int)(width*scale), (int)(height*scale));
			
	}
	
	
	
	
	
	
	
	
	
	
	
	
	public void start_animation(Panel panel){
		(new WobbleAnimation(panel)).start();
	}
	
	
	class WobbleAnimation extends Thread {
		Panel panel;
		double original_width;
		double original_height;
		WobbleAnimation(Panel panel){
			this.panel = panel;	
			original_width = width;
			original_height = height;
		}
		public void run() {
			for(int i=0; i<=10; i++){
				try{
					sleep(50);
				}
				catch(InterruptedException e){}
				
				double t = i / 10.0;
				width = original_width  * (1+(t-t*t)*2);
				height = original_height* (1+(t-t*t)*2);
			
				panel.repaint();
				
			}
			width = original_width;
			height = original_height;
			
		}
	}
	
	
}
